Option Explicit On 
Option Strict On
'todo lo que importamos es necesario declararlo como codigo
Imports CrystalDecisions
Imports CrystalDecisions.Web
Imports CrystalDecisions.Shared
Imports CrystalDecisions.ReportSource
Imports CrystalDecisions.CrystalReports.Engine
Imports Microsoft
Imports System.Data.DataSet
Imports System.Data.OleDb
Imports System.Data.OleDb.OleDbType
Imports System.Data
Imports System.Xml
Imports System.Drawing.Printing
Imports System
Imports System.IO
Imports System.Data.Common.DbDataAdapter
Public Class WebForm1
    Inherits System.Web.UI.Page
    Protected WithEvents CrystalReportViewer1 As CrystalDecisions.Web.CrystalReportViewer

#Region " Cdigo generado por el Diseador de Web Forms "
    'declaracion de variables para obtener infomacion acerca de la conexion
    Private crtablelogoninfos As New TableLogOnInfos()
    Private crtablelogoninfo As New TableLogOnInfo()
    Private crconnectioninfo As New ConnectionInfo()
    Private crreportdocument As New ReportDocument()
    Private imprimirdoc As New PrinterSettings()
    Private crtables As Tables
    Private crtable As Table
    Private tablecounter As Integer
    Private inte As String
    Protected WithEvents Button1 As System.Web.UI.WebControls.Button
    Protected WithEvents Button2 As System.Web.UI.WebControls.Button
    Protected WithEvents ddrptnomimp As System.Web.UI.WebControls.DropDownList
    Protected WithEvents Button3 As System.Web.UI.WebControls.Button

    '   DECLARACINES DE MARGEN
    Private margen As PageMargins

    'El Diseador de Web Forms requiere esta llamada.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: el Diseador de Web Forms requiere esta llamada de mtodo
        'No lo modifique con el editor de cdigo.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Introducir aqu el cdigo de usuario para inicializar la pgina
        cargar()
    End Sub
    'funcion para cargar el reporte
    Sub cargar()
        Dim crTables As CrystalDecisions.CrystalReports.Engine.Tables  ' declaracion de una variable de tipo tablas
        Dim crTable As CrystalDecisions.CrystalReports.Engine.Table ' declaracion de una variable de tipo tabla
        Dim crConnInfo As New CrystalDecisions.Shared.ConnectionInfo() ' declaracion de una variable de tipo connectioninfo para el reportdocument
        Dim crLogOnInfo As CrystalDecisions.Shared.TableLogOnInfo '' declaracion de una variable de tipo connectioninfo para la tabla

        rptservidor = "orantes" 'el nombre del servidor
        rptlogin = "usuario" 'login de usuario que opera sabre la base de datos
        rptpassword = "a123456" ' contrasea del usuario
        rptnombd = "Northwind" ' nombre de la base de datos que vamos a utilizar
        rptnomb_report = "informe" ' el nombre del reporte
        rutarpt = Server.MapPath(rptnomb_report & ".rpt") ' indica la ruta en donde se encuentra el reporte dentro del directorio virtual
        crreportdocument.Load(rutarpt)  ' carga el reporque que indicamos en la ruta anterior

        '   fase para cargar la informacion antes definida para cada una de las tablas
        'utilizadas en el reporte
        crTables = crreportdocument.Database.Tables
        For Each crTable In crTables
            crConnInfo.DatabaseName = rptnombd ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de datos
            crConnInfo.ServerName = rptservidor ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base del servidor
            crConnInfo.UserID = rptlogin  ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de usuario
            crConnInfo.Password = rptpassword ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de contrasea
            crLogOnInfo = crTable.LogOnInfo ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de las tablas
            crLogOnInfo.ConnectionInfo = crConnInfo ' asigna al connectioninfo, que es la misma informacion de conexion del reporte
            crTable.ApplyLogOnInfo(crLogOnInfo) ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de la tabla
        Next
        'fase para cargar el reporte en el visor
        CrystalReportViewer1.ReportSource = crreportdocument ' indica la direccion del reporte en el visor
        CrystalReportViewer1.DataBind() ' ejecuta la carga del reporte al visor, es decir despliega la informacion

    End Sub
    'funcion para imprimir el reporte
    Sub imprimir()
        'fase para determinar los margenes de la pagina
        ' a imprimir
        Dim margins As CrystalDecisions.Shared.PageMargins
        Dim informacion As CrystalDecisions.Shared.ReportInfo
        margins = crreportdocument.PrintOptions.PageMargins
        margins.bottomMargin = 350 'margen inferior
        margins.leftMargin = 350 'margen izquierdo
        margins.rightMargin = 350 'margen derecho
        margins.topMargin = 350 'margen superior
        crreportdocument.PrintOptions.ApplyPageMargins(margins) 'aplica los margenes
        'aca se determina el nombre del impresor que se selecciono
        crreportdocument.PrintOptions.PrinterName = ddrptnomimp.SelectedItem.Text
        crreportdocument.PrintToPrinter(1, False, 0, 0)
    End Sub
    Private Sub instalarimpresoras()
        'fase para desplegar la lista de las impresoras disponibles en el PC
        Dim i As Integer
        Dim pkInstalledPrinters As String
        For i = 0 To PrinterSettings.InstalledPrinters.Count - 1
            pkInstalledPrinters = PrinterSettings.InstalledPrinters(i)
            ddrptnomimp.Items.Add(pkInstalledPrinters)
        Next
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        cargar()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'antes de mandar a imprimir es necesario cargar primero el reporte
        cargar()
        imprimir()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        instalarimpresoras()
    End Sub
End Class
